3 # Copyright (C) The Arvados Authors. All rights reserved.
5 # SPDX-License-Identifier: CC-BY-SA-3.0
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
20 echo >&2 "Usage: ${0} [-h] [-h]"
22 echo >&2 "${0} options:"
23 echo >&2 " -d, --debug Run salt installation in debug mode"
24 echo >&2 " -c <local.params>, --config <local.params> Path to the local.params config file"
25 echo >&2 " -t, --test Test installation running a CWL workflow"
26 echo >&2 " -r, --roles List of Arvados roles to apply to the host, comma separated"
27 echo >&2 " Possible values are:"
29 echo >&2 " controller"
30 echo >&2 " dispatcher"
32 echo >&2 " keepbalance"
39 echo >&2 " workbench2"
40 echo >&2 " Defaults to applying them all"
41 echo >&2 " -h, --help Display this help and exit"
42 echo >&2 " --dump-config <dest_dir> Dumps the pillars and states to a directory"
43 echo >&2 " This parameter does not perform any installation at all. It's"
44 echo >&2 " intended to give you a parsed sot of configuration files so"
45 echo >&2 " you can inspect them or use them in you Saltstack infrastructure."
47 echo >&2 " - parses the pillar and states templates,"
48 echo >&2 " - downloads the helper formulas with their desired versions,"
49 echo >&2 " - prepares the 'top.sls' files both for pillars and states"
50 echo >&2 " for the selected role/s"
51 echo >&2 " - writes the resulting files into <dest_dir>"
52 echo >&2 " -v, --vagrant Run in vagrant and use the /vagrant shared dir"
53 echo >&2 " --development Run in dev mode, using snakeoil certs"
58 # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
59 if ! which getopt > /dev/null; then
60 echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
64 TEMP=$(getopt -o c:dhp:r:tv \
65 --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
69 then echo "Please check the parameters you entered and re-run again"
72 # Note the quotes around `$TEMP': they are essential!
75 while [ ${#} -ge 1 ]; do
87 if [[ ${2} = /* ]]; then
88 DUMP_SALT_CONFIG_DIR=${2}
90 DUMP_SALT_CONFIG_DIR=${PWD}/${2}
93 S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
95 F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
97 P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
99 T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
110 # Verify the role exists
111 if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
112 echo "The role '${i}' is not a valid role"
116 ROLES="${ROLES} ${i}"
144 mkdir -p /srv/salt/certs
146 if [ -f ${cert_dir}/${cert_name}.crt ]; then
147 cp -v ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
149 echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
152 if [ -f ${cert_dir}/${cert_name}.key ]; then
153 cp -v ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
155 echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
161 CONFIG_FILE="${SCRIPT_DIR}/local.params"
162 CONFIG_DIR="local_config_dir"
165 CONTROLLER_EXT_SSL_PORT=443
168 NGINX_INSTALL_SOURCE="install_from_repo"
173 # Hostnames/IPs used for single-host deploys
178 INITIAL_USER_EMAIL=""
179 INITIAL_USER_PASSWORD=""
181 CONTROLLER_EXT_SSL_PORT=8000
182 KEEP_EXT_SSL_PORT=25101
183 # Both for collections and downloads
184 KEEPWEB_EXT_SSL_PORT=9002
185 WEBSHELL_EXT_SSL_PORT=4202
186 WEBSOCKET_EXT_SSL_PORT=8002
187 WORKBENCH1_EXT_SSL_PORT=443
188 WORKBENCH2_EXT_SSL_PORT=3001
190 SSL_MODE="self-signed"
191 USE_LETSENCRYPT_ROUTE53="no"
192 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/certs"
194 ## These are ARVADOS-related parameters
195 # For a stable release, change RELEASE "production" and VERSION to the
196 # package version (including the iteration, e.g. X.Y.Z-1) of the
198 # The "local.params.example.*" files already set "RELEASE=production"
199 # to deploy production-ready packages
200 RELEASE="development"
203 # These are arvados-formula-related parameters
204 # An arvados-formula tag. For a stable release, this should be a
205 # branch name (e.g. X.Y-dev) or tag for the release.
206 # ARVADOS_TAG="2.2.0"
209 # Other formula versions we depend on
210 POSTGRES_TAG="v0.44.0"
214 LETSENCRYPT_TAG="v2.1.0"
217 DUMP_SALT_CONFIG_DIR=""
221 F_DIR="/srv/formulas"
225 T_DIR="/tmp/cluster_tests"
229 if [ -s ${CONFIG_FILE} ]; then
230 source ${CONFIG_FILE}
232 echo >&2 "You don't seem to have a config file with initial values."
233 echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
234 echo >&2 " * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
235 echo >&2 " * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
239 if [ ! -d ${CONFIG_DIR} ]; then
240 echo >&2 "You don't seem to have a config directory with pillars and states."
241 echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
242 echo >&2 " * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
243 echo >&2 " * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
247 if grep -q 'fixme_or_this_wont_work' ${CONFIG_FILE} ; then
248 echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
249 echo >&2 "Please, fix them and re-run the provision script."
253 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
254 echo >&2 "ERROR: <CLUSTER> must be exactly 5 alphanumeric characters long"
255 echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
259 # Only used in single_host/single_name deploys
260 if [ ! -z "${HOSTNAME_EXT}" ] ; then
261 # We need to add some extra control vars to manage a single certificate vs. multiple
262 USE_SINGLE_HOSTNAME="yes"
263 # Make sure that the value configured as IP_INT is a real IP on the system.
264 # If we don't error out early here when there is a mismatch, the formula will
265 # fail with hard to interpret nginx errors later on.
266 ip addr list |grep -q "${IP_INT}/"
267 if [[ $? -ne 0 ]]; then
268 echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
272 USE_SINGLE_HOSTNAME="no"
273 # We set this variable, anyway, so sed lines do not fail and we don't need to add more
275 HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
278 if [ "${DUMP_CONFIG}" = "yes" ]; then
279 echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
281 # Install a few dependency packages
282 # First, let's figure out the OS we're working on
283 OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d= |cut -f 2 -d \")
284 echo "Detected distro: ${OS_ID}"
288 echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
289 sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
290 setenforce permissive
291 yum install -y curl git jq
294 DEBIAN_FRONTEND=noninteractive apt update
295 DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
299 if which salt-call; then
300 echo "Salt already installed"
302 curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
303 sh /tmp/bootstrap_salt.sh -XdfP -x python3
304 /bin/systemctl stop salt-minion.service
305 /bin/systemctl disable salt-minion.service
308 # Set salt to masterless mode
309 cat > /etc/salt/minion << EOFSM
324 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
326 # Get the formula and dependencies
327 cd ${F_DIR} || exit 1
328 echo "Cloning formulas"
329 rm -rf ${F_DIR}/* || exit 1
330 git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
331 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" -b "${DOCKER_TAG}" )
334 git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
335 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" -b "${LOCALE_TAG}" )
338 git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
339 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" -b "${NGINX_TAG}" )
342 git clone --quiet https://github.com/saltstack-formulas/postgres-formula.git ${F_DIR}/postgres
343 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" -b "${POSTGRES_TAG}" )
345 echo "...letsencrypt"
346 git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
347 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" -b "${LETSENCRYPT_TAG}" )
350 git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
352 # If we want to try a specific branch of the formula
353 if [ "x${BRANCH}" != "x" ]; then
354 ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
355 elif [ "x${ARVADOS_TAG}" != "x" ]; then
356 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
359 if [ "x${VAGRANT}" = "xyes" ]; then
360 EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
361 SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
362 SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
364 EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
365 SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
366 SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
369 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
371 echo "Writing pillars and states"
373 # Replace variables (cluster, domain, etc) in the pillars, states and tests
374 # to ease deployment for newcomers
375 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
376 echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
379 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
380 sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
381 s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
382 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
383 s#__CLUSTER__#${CLUSTER}#g;
384 s#__DOMAIN__#${DOMAIN}#g;
385 s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
386 s#__IP_INT__#${IP_INT}#g;
387 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
388 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
389 s#__INITIAL_USER__#${INITIAL_USER}#g;
390 s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
391 s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
392 s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
393 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
394 s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
395 s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
396 s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
397 s#__RELEASE__#${RELEASE}#g;
398 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
399 s#__VERSION__#${VERSION}#g;
400 s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
401 s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
402 s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
403 s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
404 s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
405 s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
406 s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
407 s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
408 s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
409 s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
410 s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
411 s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
412 s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
413 s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
414 s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
415 s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
416 s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
417 "${f}" > "${P_DIR}"/$(basename "${f}")
420 if [ ! -d "${SOURCE_TESTS_DIR}" ]; then
421 echo "WARNING: The tests directory was not copied to \"${SOURCE_TESTS_DIR}\"."
422 if [ "x${TEST}" = "xyes" ]; then
423 echo "WARNING: Disabling tests for this installation."
428 # Replace cluster and domain name in the test files
429 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
430 FILTERS="s#__CLUSTER__#${CLUSTER}#g;
431 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
432 s#__DOMAIN__#${DOMAIN}#g;
433 s#__IP_INT__#${IP_INT}#g;
434 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
435 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
436 s#__INITIAL_USER__#${INITIAL_USER}#g;
437 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
438 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
439 if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
440 FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
444 "${f}" > ${T_DIR}/$(basename "${f}")
446 chmod 755 ${T_DIR}/run-test.sh
449 # Replace helper state files that differ from the formula's examples
450 if [ -d "${SOURCE_STATES_DIR}" ]; then
451 mkdir -p "${F_DIR}"/extra/extra
453 for f in $(ls "${SOURCE_STATES_DIR}"/*); do
454 sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
455 s#__CLUSTER__#${CLUSTER}#g;
456 s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
457 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
458 s#__DOMAIN__#${DOMAIN}#g;
459 s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
460 s#__IP_INT__#${IP_INT}#g;
461 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
462 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
463 s#__INITIAL_USER__#${INITIAL_USER}#g;
464 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
465 s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
466 s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
467 s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
468 s#__RELEASE__#${RELEASE}#g;
469 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
470 s#__VERSION__#${VERSION}#g;
471 s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
472 s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
473 s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
474 s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
475 s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
476 s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
477 s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
478 s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
479 s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
480 s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
481 s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
482 s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
483 s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
484 s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
485 s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
486 s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
487 s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
488 "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
492 # Now, we build the SALT states/pillars trees
493 # As we need to separate both states and pillars in case we want specific
494 # roles, we iterate on both at the same time
497 cat > ${S_DIR}/top.sls << EOFTSLS
504 cat > ${P_DIR}/top.sls << EOFPSLS
511 # States, extra states
512 if [ -d "${F_DIR}"/extra/extra ]; then
513 SKIP_SNAKE_OIL="snakeoil_certs"
515 if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
516 # In dev mode, we create some snake oil certs that we'll
517 # use as CUSTOM_CERTS, so we don't skip the states file.
518 # Same when using self-signed certificates.
519 SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
521 for f in $(ls "${F_DIR}"/extra/extra/*.sls | egrep -v "${SKIP_SNAKE_OIL}|shell_"); do
522 echo " - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
524 # Use byo or self-signed certificates
525 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
526 mkdir -p "${F_DIR}"/extra/extra/files
530 # If we want specific roles for a node, just add the desired states
531 # and its dependencies
532 if [ -z "${ROLES}" ]; then
534 echo " - nginx.passenger" >> ${S_DIR}/top.sls
535 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
536 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
537 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - extra.aws_credentials" >> ${S_DIR}/top.sls
539 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
541 # Use custom certs, as both bring-your-own and self-signed are copied using this state
542 # Copy certs to formula extra/files
543 # In dev mode, the files will be created and put in the destination directory by the
544 # snakeoil_certs.sls state file
545 mkdir -p /srv/salt/certs
546 cp -rv ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
547 # We add the custom_certs state
548 grep -q "custom_certs" ${S_DIR}/top.sls || echo " - extra.custom_certs" >> ${S_DIR}/top.sls
551 echo " - postgres" >> ${S_DIR}/top.sls
552 echo " - docker.software" >> ${S_DIR}/top.sls
553 echo " - arvados" >> ${S_DIR}/top.sls
554 echo " - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
555 echo " - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
558 echo " - docker" >> ${P_DIR}/top.sls
559 echo " - nginx_api_configuration" >> ${P_DIR}/top.sls
560 echo " - nginx_controller_configuration" >> ${P_DIR}/top.sls
561 echo " - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
562 echo " - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
563 echo " - nginx_passenger" >> ${P_DIR}/top.sls
564 echo " - nginx_websocket_configuration" >> ${P_DIR}/top.sls
565 echo " - nginx_webshell_configuration" >> ${P_DIR}/top.sls
566 echo " - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
567 echo " - nginx_workbench_configuration" >> ${P_DIR}/top.sls
568 echo " - postgresql" >> ${P_DIR}/top.sls
570 # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
571 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
572 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
574 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
575 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
576 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
578 grep -q "letsencrypt" ${P_DIR}/top.sls || echo " - letsencrypt" >> ${P_DIR}/top.sls
580 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
581 for c in controller websocket workbench workbench2 webshell download collections keepproxy; do
582 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${c}.${CLUSTER}.${DOMAIN}*/g;
583 s#__CERT_PEM__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
584 s#__CERT_KEY__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
585 ${P_DIR}/nginx_${c}_configuration.sls
588 # Use custom certs (either dev mode or prod)
589 grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo " - extra_custom_certs" >> ${P_DIR}/top.sls
590 # And add the certs in the custom_certs pillar
591 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
592 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
594 for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
595 # Are we in a single-host-single-hostname env?
596 if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
597 # Are we in a single-host-single-hostname env?
598 CERT_NAME=${HOSTNAME_EXT}
600 # We are in a multiple-hostnames env
604 if [[ "$SSL_MODE" == "bring-your-own" ]]; then
605 copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
608 grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo " - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
610 # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
611 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
612 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
613 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
614 ${P_DIR}/nginx_${c}_configuration.sls
618 # If we add individual roles, make sure we add the repo first
619 echo " - arvados.repo" >> ${S_DIR}/top.sls
620 # We add the extra_custom_certs state
621 grep -q "extra.custom_certs" ${S_DIR}/top.sls || echo " - extra.custom_certs" >> ${S_DIR}/top.sls
623 # And we add the basic part for the certs pillar
624 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
625 # And add the certs in the custom_certs pillar
626 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
627 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
628 grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo " - extra_custom_certs" >> ${P_DIR}/top.sls
631 for R in ${ROLES}; do
635 echo " - postgres" >> ${S_DIR}/top.sls
637 echo ' - postgresql' >> ${P_DIR}/top.sls
641 # FIXME: https://dev.arvados.org/issues/17352
642 grep -q "postgres.client" ${S_DIR}/top.sls || echo " - postgres.client" >> ${S_DIR}/top.sls
643 if grep -q " - nginx.*$" ${S_DIR}/top.sls; then
644 sed -i s/"^ - nginx.*$"/" - nginx.passenger"/g ${S_DIR}/top.sls
646 echo " - nginx.passenger" >> ${S_DIR}/top.sls
648 ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
649 ### after it. So we add this here as we are, after all, sharing the host for api and controller
650 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
651 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
652 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - aws_credentials" >> ${S_DIR}/top.sls
654 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
657 if [ "${SSL_MODE}" = "bring-your-own" ]; then
658 copy_custom_cert ${CUSTOM_CERTS_DIR} controller
660 grep -q controller ${P_DIR}/extra_custom_certs.sls || echo " - controller" >> ${P_DIR}/extra_custom_certs.sls
662 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
664 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
665 grep -q "postgresql" ${P_DIR}/top.sls || echo " - postgresql" >> ${P_DIR}/top.sls
666 grep -q "nginx_passenger" ${P_DIR}/top.sls || echo " - nginx_passenger" >> ${P_DIR}/top.sls
667 grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo " - nginx_${R}_configuration" >> ${P_DIR}/top.sls
669 # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
670 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
671 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
673 "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
675 if [ "${R}" = "workbench" ]; then
676 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
677 if grep -q " - nginx$" ${S_DIR}/top.sls; then
678 sed -i s/"^ - nginx.*$"/" - nginx.passenger"/g ${S_DIR}/top.sls
680 echo " - nginx.passenger" >> ${S_DIR}/top.sls
683 grep -q "nginx" ${S_DIR}/top.sls || echo " - nginx" >> ${S_DIR}/top.sls
685 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
686 if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
687 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - aws_credentials" >> ${S_DIR}/top.sls
689 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
691 # Use custom certs, special case for keepweb
692 if [ ${R} = "keepweb" ]; then
693 if [ "${SSL_MODE}" = "bring-your-own" ]; then
694 copy_custom_cert ${CUSTOM_CERTS_DIR} download
695 copy_custom_cert ${CUSTOM_CERTS_DIR} collections
698 if [ "${SSL_MODE}" = "bring-your-own" ]; then
699 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
703 # webshell role is just a nginx vhost, so it has no state
704 if [ "${R}" != "webshell" ]; then
705 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
708 grep -q "nginx_passenger" ${P_DIR}/top.sls || echo " - nginx_passenger" >> ${P_DIR}/top.sls
709 grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo " - nginx_${R}_configuration" >> ${P_DIR}/top.sls
710 # Special case for keepweb
711 if [ ${R} = "keepweb" ]; then
712 grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo " - nginx_download_configuration" >> ${P_DIR}/top.sls
713 grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo " - nginx_collections_configuration" >> ${P_DIR}/top.sls
716 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
717 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
718 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
720 grep -q "letsencrypt" ${P_DIR}/top.sls || echo " - letsencrypt" >> ${P_DIR}/top.sls
721 grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo " - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
723 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
724 # Special case for keepweb
725 if [ ${R} = "keepweb" ]; then
726 for kwsub in download collections; do
727 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
728 s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
729 s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
730 ${P_DIR}/nginx_${kwsub}_configuration.sls
733 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
734 s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
735 s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
736 ${P_DIR}/nginx_${R}_configuration.sls
739 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
740 # Special case for keepweb
741 if [ ${R} = "keepweb" ]; then
742 for kwsub in download collections; do
743 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
744 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
745 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
746 ${P_DIR}/nginx_${kwsub}_configuration.sls
747 grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo " - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
750 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
751 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
752 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
753 ${P_DIR}/nginx_${R}_configuration.sls
754 grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
757 # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
758 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
762 echo " - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
763 echo " - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
764 grep -q "docker" ${S_DIR}/top.sls || echo " - docker.software" >> ${S_DIR}/top.sls
765 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
767 grep -q "docker" ${P_DIR}/top.sls || echo " - docker" >> ${P_DIR}/top.sls
769 "dispatcher" | "keepbalance" | "keepstore")
771 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
773 # ATM, no specific pillar needed
776 echo "Unknown role ${R}"
783 if [ "${DUMP_CONFIG}" = "yes" ]; then
784 # We won't run the rest of the script because we're just dumping the config
788 # Now run the install
789 salt-call --local state.apply -l ${LOG_LEVEL}
791 # Finally, make sure that /etc/hosts is not overwritten on reboot
792 if [ -d /etc/cloud/cloud.cfg.d ]; then
793 # TODO: will this work on CentOS?
794 sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
797 # Leave a copy of the Arvados CA so the user can copy it where it's required
798 if [ "$DEV_MODE" = "yes" ]; then
799 echo "Copying the Arvados CA certificate to the installer dir, so you can import it"
800 # If running in a vagrant VM, also add default user to docker group
801 if [ "x${VAGRANT}" = "xyes" ]; then
802 cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
804 echo "Adding the vagrant user to the docker group"
805 usermod -a -G docker vagrant
807 cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
811 # Test that the installation finished correctly
812 if [ "x${TEST}" = "xyes" ]; then
814 # If we use RVM, we need to run this with it, or most ruby commands will fail
816 if [ -x /usr/local/rvm/bin/rvm-exec ]; then
817 RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
819 ${RVM_EXEC} ./run-test.sh